// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 11 marzo 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ILFD InstrumentalLaboratorioFantasiaDomestico
// El archivo dibuja un laboratorio ficticio...
// Simplemente son inventados, pese al parecido con algo que usted haya visto.
// lo "divertido" es utilizar intensamente el archivo
// #include "functions.inc", y unos poquitos 
// rectangulos, cilindros, esferas y text para uniones y cosas asi... 
// Ademas se utilizaron casi textuales funciones de archivos por Alexander Enzmann
// en el subdirectorio POVRay objects\quartic\*.pov 
// siendo entidades matematicas, supuse que no le molestaria. 
//
// La macro utililzada es muy poco flexible.
// #macro ILFD_Laboratory( Semilla )   
//      Semilla         : Valor para la generacion de numeros aleatorios.
//                        Mismo valor inicial, repite patron.
//
// Las dimensiones del laboratorio son :
//      Alto total              =  1425*L
//      Fondo                   =   500*L aprox
//      Frente                  = -1220*L..1000*L   
// Se dibuja parcialemente centrado sobre el origen del plano XZ.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare ILFD_TexturaCrisol     
//      Textura del crisol de porcelada.
// #declare ILFD_TexturaPistilo   
//      Textura del pistilo del crisol de porcelana. 
// #declare ILFD_TexturaContacto    
//      Textura para la zona de contacto crisol y pistilo.
// #declare ILFD_TexturaMadera 
//      Textura para las repisas del laboratorio.  
// #declare ILFD_TexturaSoporteDestiladores 
//      Textura para la base del destilador.  
// #declare ILFD_TexturaTapa  
//      Textura del tapas del horno magnetico.    
// #declare ILFD_MaterialEspiral  
//      Material de la espiral del horno magnetico. 
// #declare ILFD_MaterialCilindro    
//      Material del vidrio del horno magnetico y de los perfiles de vidrio libres.
// #declare ILFD_MaterialDestilador 
//      Material principal del destilador. 
// #declare ILFD_MaterialCuelloDestilador   
//      Material del colector del destilador.
// #declare ILFD_TexturaAgarre   
//      Textura de agarre de la espiral del horno magnetico.  
// #declare ILFD_MaterialMagneto 
//      Material del magneto del horno.  
// #declare ILFD_MaterialSuperior6
//      Material del descanso superior del colector distribuidor de flujo.  
// #declare ILFD_MaterialSoporte6                                         
//      Material de la capa del colector distribuidor de flujo.
// #declare ILFD_MaterialExtractor6  
//      Material del generador de vacio.
// #declare ILFD_MaterialPata6          
//      Material de los colectores del colector distribuidor de flujo.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ILFD_BanderaTexto                           = on;
//      Valor "off" elimina el texto.  "on" si lo dibuja.
// #declare ILFD_Texto                                  = "f(X)"; 
//      Texto a escribir.
// #declare ILFD_FactorXTexto                           = 1.00;             
//      Para corregir el largo del soporte horizontal del texto en forma
//      proporcional.                                                    
// #declare ILFD_TranslateTexto                         = <0,0,0>;
//      Para corregir la posicion del texto.
// #declare ILFD_DefaultTexturaCrisol                   = texture  { ... }
//      Textura a aplicar al crisol de porcelana.
// #declare ILFD_DefaultTexturaPistilo                  = texture  { ... }
//      Textura del pistilo para el crisol de porcelana.
// #declare ILFD_DefaultTexturaContacto                 = texture  { ... }
//      Textura para la zona de contacto crisol y pistilo.
// #declare ILFD_DefaultTexturaMadera                   = texture  { ... }  
//      Textura para las repisas del laboratorio.
// #declare ILFD_DefaultTexturaSoporteDestiladores      = texture  { ... } 
//      Textura para la base del destilador.                       
// #declare ILFD_DefaultTexturaTapa                     = texture  { ... }
//      Textura de tapas del horno magnetico.
// #declare ILFD_DefaultMaterialEspiral                 = material { ... }
//      Material de espiral del horno magnetico.
// #declare ILFD_DefaultMaterialCilindro                = material { ... }     
//      Material del vidrio del horno magnetico, y de los
//      perfiles de vidrio libres.
// #declare ILFD_DefaultMaterialDestilador              = material { ... }
//      Material principal del destilador.  
// #declare ILFD_DefaultMaterialCuelloDestilador        = material { ... }
//      Material del colector del destilador. 
// #declare ILFD_DefaultTexturaAgarre                   = texture  { ... }
//      Textura de agarre de la espiral del horno magnetico.
// #declare ILFD_DefaultMaterialMagneto                 = material { ... }
//      Material del magneto del horno.
// #declare ILFD_DefaultMaterialSuperior6               = material { ... } 
//      Material del descanso superior del colector-distribuidor de flujo.
// #declare ILFD_DefaultMaterialSoporte6                = material { ... }
//      Material de la capa del colector distribuidor de flujo.
// #declare ILFD_DefaultMaterialExtractor6              = material { ... } 
//      Material del generador de vacio.
// #declare ILFD_DefaultMaterialPata6                   = material { ... } 
//      Material de los colectores del colector distribuidor de flujo.
//
// Para colocarlo simplemente
// #include "ILFD.inc"
// object        { ILFD_Laboratory( 300 ) }
//
// Otro ejemplo con modificador
// #include "ILFD.inc"
// #declare ILFD_DefaultTexturaMadera        = texture       {
//   average
//   texture_map        {
//     [ 0.5 ILFD_TexturaMadera         ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      ILFD_Laboratory( 300 )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "ILFD.inc"   

#local FactorAcercamiento       = 0.8;

object                          { 
  ILFD_Laboratory( 200 )
  translate             -700*L*y  
  rotate        20*y        
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z
}   

